#!/bin/sh
#
# update-dns-ip.sh
#
# This script updates Dynamic DNS records on DNE Made Easy's
# DNS servers.  You must have wget installed for this to work.
#
# Author: Jeff Larkin <fu_fish@users.sourceforge.net>
# Last Modified: 08-February-2002
# Modified on 06-Mar-2002 by Jonathan Loran <jonloran@yahoo.com>, to get
#	WAN IP address from a Netgear RT31x router.  Relies
#	on expect script get-wan-ip.exp
#
# This script is released as public domain in hope that it will
# be useful to others using DNS Made Easy.  It is provided
# as-is with no warranty implied.  Sending passwords as a part 
# of an HTTP request is inherently insecure.  I take no responsibility
# if your password is discovered by use of this script.
#

PATH=${PATH}:/opt/dnsupdater
export PATH

# This is the e-mail address that you use to login
DMEUSER=<username>

# This is your password
DMEPASS=<password>

# This is the router address (may be local DNS/hostname)
ROUTERADDR=<your router address>

# This is the router password
ROUTERPASS=<your router password>

# This is the file where the locally stored "last" known IP lives. 
LASTIPFILE=<your choice.  I use /var/tmp/last_wan_ip>

# This is the unique number for the record that you are updating.
# This number can be obtained by clicking on the DDNS link for the
# record that you wish to update; the number for the record is listed
# on the next page.
DMEID=<record number>

# Obtain current ip address
IPADDR=`get_wan_ip.exp $ROUTERADDR $ROUTERPASS`

if [ -f $LASTIPFILE ] ; then
	LASTIP=`cat $LASTIPFILE`
else
	LASTIP=""
fi

# Update only if IP changed
if [ "_${LASTIP}_" != "_${IPADDR}_" ] ; then
	if wget -q -O /proc/self/fd/1 http://cp.dnsmadeeasy.com/servlet/updateip\?username=$DMEUSER\&password=$DMEPASS\&id=$DMEID\&ip=$IPADDR | egrep success\|same > /dev/null; then
		logger -t `basename $0` -s "DNS Record Updated Successfully"
		echo $IPADDR > $LASTIPFILE
	else
		logger -t `basename $0` -s "Problem updating DNS record."
	fi
fi


# David Harris's script for dynodns.net was used as an example
# in writing this script.
